Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Material/MaterialReturnEntry/FrmMaterialReturnEntry.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Material/MaterialReturnEntry/FrmMaterialReturnEntry.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Material/MaterialReturnEntry/FrmMaterialReturnEntry.cs	(revision 51)
@@ -0,0 +1,986 @@
+using System;
+using System.Collections.Generic;
+using System.Collections;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using System.Linq;
+using System.Diagnostics;
+using System.Threading;
+using System.Text.RegularExpressions;
+
+using log4net;
+using log4net.Appender;
+using log4net.Repository.Hierarchy;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB.Core;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.Master;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+
+//*------------------------ 単位マスタメンテ画面 ----------------------*
+//  2015/07/14  Ver1.0.0.0      Create Source           
+//
+//
+//
+//*----------------------------------------------------------------------------*
+namespace ProcessManagement.Forms.DataEntry
+{
+    public partial class FrmMaterialReturnEntry : Form
+    {
+        #region 使用定義
+        //log4netログを使用する
+        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+        /// <summary>
+        /// 表示カラム
+        /// </summary>
+        private enum DispColumn
+        {
+            DisplayOrder = 0,
+            MaterialKindCode,
+            MaterialKindName,
+            MaterialKindDisplayOrder,
+            MaterialItemCode,
+            MaterialItemName,
+            MaterialItemDisplayOrder,
+            RentCount,
+            RepayCount,
+            MaterialCount,
+            MaterialCountBefore,
+            CommentText,
+        }
+
+        private enum DataColumn
+        {
+            MaterialKindCode = 0,
+            MaterialKindName,
+            KindDisp,
+            MaterialItemCode,
+            MaterialItemName,
+            ItemDisp,
+            RENTCOUNT,
+            REPAYCOUNT,
+            MaterialCount,
+            CommentText,
+            CompleteFlg,
+        }
+
+        /// <summary>
+        /// マスタリストMAXライン
+        /// </summary>
+        private const int s_ListMaxLineCount = 53;
+        #endregion
+
+        #region 変数
+        /// <summary>
+        /// フィールド値変化フラグ
+        /// </summary>
+        private bool m_bChengeAns = false;
+
+        /// <summary>
+        /// ダイアログ使用フラグ
+        /// </summary>
+        private bool m_DialogFlg = false;
+        /// <summary>
+        /// 工事番号
+        /// </summary>
+        private int m_ConstructionCode = 0;
+        /// <summary>
+        /// 終了ボタン押下フラグ
+        /// </summary>
+        private bool m_EndButton = false;
+        /// <summary>
+        /// 参照フラグ
+        /// </summary>
+        private bool m_EditLock = false;
+
+        // *-----* 共通処理設定 *-----*
+        /// <summary>
+        /// サブフォームフラグ
+        /// </summary>
+        private bool m_SubForm = false;
+        /// <summary>
+        /// 呼出元終了フラグ
+        /// </summary>
+        private bool m_ParentEnd = false;
+
+        // *-----* 共通処理設定 *-----*
+
+        private bool m_CloseingProcessOn = false;
+
+        #endregion
+
+        #region コンストラクタ
+        public FrmMaterialReturnEntry()
+        {
+            InitializeComponent();
+        }
+        #endregion
+        #region デストラクタ
+        ~FrmMaterialReturnEntry()
+        {
+            try
+            {
+                GC.Collect();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+
+        #region プロパティ
+        /// <summary>
+        /// ダイアログ使用時フラグ
+        /// </summary>
+        public bool DialogUsed
+        {
+            set { m_DialogFlg = value; }
+        }
+        /// <summary>
+        /// 工事番号
+        /// </summary>
+        public int ConstructionCode
+        {
+            get { return m_ConstructionCode; }
+            set { m_ConstructionCode = value; }
+
+        }
+        /// <summary>
+        /// 参照フラグ
+        /// </summary>
+        public bool EditLock
+        {
+            get { return m_EditLock; }
+            set { m_EditLock = value; }
+        }
+
+        // *-----* 共通処理設定 *-----*
+        /// <summary>
+        /// サブフォームフラグ
+        /// </summary>
+        public bool SubForm
+        {
+            get { return m_SubForm; }
+            set { m_SubForm = value; }
+        }
+        /// <summary>
+        /// 呼出元終了フラグ
+        /// </summary>
+        public bool ParentEnd
+        {
+            get { return m_ParentEnd; }
+            set { m_ParentEnd = value; }
+        }
+        // *-----* 共通処理設定 *-----*
+
+        #endregion
+
+
+        #region イベントメソッド
+        /// <summary>
+        /// ×ボタン押下処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialReturnEntry_FormClosing(object sender, FormClosingEventArgs e)
+        {
+            if (m_EndButton) return;
+            if (m_bChengeAns)
+            {
+                if (MessageBox.Show("データに変更があります、登録せずに終了してよろしいですか？。", "終了確認"
+                                , MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.No)
+                {
+                    e.Cancel = true;
+                    return;
+                }
+            }
+            // 前プロセスに戻る
+            ClsExcute.BackProcess();
+        }
+        /// <summary>
+        /// 終了ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnEnd_Click(object sender, EventArgs e)
+        {
+            this.Close();
+        }
+
+        /// <summary>
+        /// フォームロード
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialReturnEntry_Load(object sender, EventArgs e)
+        {
+            // 初期表示
+            InitDataLoad();
+
+            if (m_EditLock) btnDataEntry.Enabled = false;
+
+            // ダイアログ使用時
+            if (m_DialogFlg)
+            {
+                //フォームの幅だけを変更する
+                this.SetBounds(this.Left, this.Top, (this.Width - 40), this.Height, BoundsSpecified.Width);
+            }
+            // フォームサイズ固定
+            this.MaximizedBounds = new Rectangle(this.Left, this.Top, this.Width, this.Height);
+
+            // ボタン表示の制御
+            ButtonVisble(this);
+
+            // *-----* 処理移動ボタン設定 *-----*
+            CreateProcessContextMenu(m_SubForm);
+            // *-----* 処理移動ボタン設定 *-----*
+
+        }
+
+        /// <summary>
+        /// 行データクリア
+        /// </summary>
+        /// <param name="iIndex">行カウント</param>
+        private void SetRowClearData(int iIndex)
+        {
+            // クリアデータセット
+        }
+
+        /// <summary>
+        /// グリッド採番処理
+        /// </summary>
+        private void LineReNumbering()
+        {
+            int icnt = 1;
+            foreach (DataGridViewRow r in dgvMaster.Rows)
+            {
+                // 表示されているものだけ採番
+                if (r.Visible)
+                    r.Cells[(int)DispColumn.DisplayOrder].Value = (icnt++).ToString();
+                else
+                    r.Cells[(int)DispColumn.DisplayOrder].Value = "0";
+            }
+        }
+        /// <summary>
+        /// 行追加ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnLineEntry_Click(object sender, EventArgs e)
+        {
+            // 行がない場合は作成して抜ける
+            if (dgvMaster.Rows.Count == 0)
+            {
+                if (MessageBox.Show("行を追加します", "追加確認"
+                                    , MessageBoxButtons.OKCancel, MessageBoxIcon.Information) == DialogResult.Cancel) return;
+
+                // 行追加
+                dgvMaster.Rows.Add();
+                // クリアデータセット
+                SetRowClearData(0);
+                // №再採番
+                LineReNumbering();
+                //　変更フラグOn
+                valueChange(sender, e);
+                // フォーカス移動
+                dgvMaster.Focus();
+                return;
+            }
+
+            // メッセージ表示
+            BtnTextCustomMessageBox msg = new BtnTextCustomMessageBox();
+            msg.ButtonText.No = "前へ追加";
+            msg.ButtonText.Yes = "後へ追加";
+            msg.ButtonText.Cancel = "キャンセル";
+            DialogResult resRet = msg.Show("行の前・後を選択してください。", "追加確認"
+                                            , MessageBoxButtons.YesNoCancel, MessageBoxIcon.Information);
+
+            // キャンセルは処理しない
+            if (resRet == DialogResult.Cancel) return;
+
+            // カレント行取得
+            int iIndex = dgvMaster.CurrentRow.Index;
+            // 最終行
+            if (iIndex == dgvMaster.RowCount - 1)
+            {
+                if (resRet == DialogResult.No)
+                {
+                    // 前
+                    dgvMaster.Rows.Insert(iIndex);
+                }
+                else if (resRet == DialogResult.Yes)
+                {
+                    // 後
+                    dgvMaster.Rows.Add();
+                    iIndex = (dgvMaster.RowCount - 1);
+                }
+            }
+            else
+            {
+                if (resRet == DialogResult.Yes)
+                {
+                    // 後ろ
+                    ++iIndex;
+                }
+                dgvMaster.Rows.Insert(iIndex);
+            }
+
+            // クリアデータセット
+            SetRowClearData(iIndex);
+
+            // №再採番
+            LineReNumbering();
+
+            //　変更フラグOn
+            valueChange(sender, e);
+
+            // フォーカス移動
+            dgvMaster.Focus();
+            //dgvMaster.FirstDisplayedScrollingRowIndex = iIndex;
+            //dgvMaster.CurrentCell = dgvMaster[0, iIndex];
+        }
+
+        /// <summary>
+        /// フィールド値変更フラグ
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void valueChange(object sender, EventArgs e)
+        {
+            m_bChengeAns = true;
+        }
+
+        /// <summary>
+        /// セル値変化
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellValueChanged(object sender, DataGridViewCellEventArgs e)
+        {
+            // インデックス外は処理しない
+            if (e.RowIndex < 0 || e.ColumnIndex < 0) return;
+
+            // 変更フラグON
+            m_bChengeAns = true;
+        }
+
+        /// <summary>
+        /// 登録ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnDataEntry_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                //データチェック
+                if (!DispFeildCheck()) return;
+
+                // 確認
+                if (tglAllReturn.Checked)
+                {
+                    if (MessageBox.Show("返却されていない資材は、資材から削除されます。完了してよろしいですか？", "登録確認"
+                            , MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return;
+                }
+                else
+                {
+                    if (MessageBox.Show("表示中のデータを登録します。", "登録確認"
+                            , MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return;
+                }
+
+                //// 表示行退避
+                //int iIndex = dgvMaster.FirstDisplayedScrollingRowIndex;
+
+                // データ登録
+                DataEntry();
+
+                // データ表示
+                if (!DispGridData()) return;
+
+                //// 表示行復元
+                //dgvMaster.FirstDisplayedScrollingRowIndex = iIndex;
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// IMEのコントロール
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellEnter(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                DataGridView dgv = (DataGridView)sender;
+
+                if (dgv.CurrentCell.ReadOnly) return;
+
+                //列によってIMEのモードを変更する
+                if (dgv.Columns[e.ColumnIndex].Name.Equals("Column3"))
+                {
+                    dgv.ImeMode = ImeMode.On;
+                }
+                else
+                {
+                    dgv.ImeMode = ImeMode.Disable;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+
+        /// <summary>
+        /// セルクリック
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellClick(object sender, DataGridViewCellEventArgs e)
+        {
+            dgvMaster_CellDoubleClick(sender, e);
+        }
+
+        /// <summary>
+        /// セルダブルクリック
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
+        {
+            // ダイアログとして使用するとき以外は処理しない
+            if (!m_DialogFlg) return;
+
+            if (e.RowIndex < 0) return;
+
+            btnEnd_Click(sender, (EventArgs)e);
+        }
+
+        /// <summary>
+        /// Formキーダウン処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialReturnEntry_KeyDown(object sender, KeyEventArgs e)
+        {
+            // DataGridviewは処理しない
+            if (ActiveControl.Name.Equals("dgvMaster"))
+            {
+                return;
+            }
+        }
+
+        #endregion
+
+        #region プライベートメソッド
+        /// <summary>
+        /// 初期表示処理
+        /// </summary>
+        private void InitDataLoad()
+        {
+            IOConstructionBaseInfoDetail IoConB = new IOConstructionBaseInfoDetail();
+            ConstructionBaseInfoDetail ConB = new ConstructionBaseInfoDetail();
+
+            try
+            {
+                // テスト用工事番号
+                //ConstructionCode = 2016020201;
+
+                // 画面表示用データ取得
+                if (!IoConB.SelectAction(string.Format(" where ConstructionCode = {0} and DETAILNO = 2", ConstructionCode), ref ConB)) return;
+
+                lblDETAILSTRING.Text = ConB.DetailString;
+
+                // 担当にログインユーザー名を表示
+                lblPerson.Text = CommonMotions.LoginUserData.PersonName;
+
+                // 返却日
+                lblRepaydate.Text = DateTime.Now.Date.ToString("yyyy/MM/dd");
+
+                if (!DispGridData()) return;
+
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 画面項目のチェック
+        /// </summary>
+        /// <returns></returns>
+        private bool DispFeildCheck()
+        {
+            bool bRet = true;
+            bool bAns = true;
+            string sError = "";
+            try
+            {
+                bAns = true;
+                foreach (DataGridViewRow r in dgvMaster.Rows)
+                {
+
+                    // 割当数＜返却済＋返却数の場合は、エラー
+                    if (CommonMotions.cnvInt(r.Cells[(int)DispColumn.RentCount].Value) < CommonMotions.cnvInt(r.Cells[(int)DispColumn.RepayCount].Value) + CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialCount].Value))
+                    {
+                        bAns = false;
+                        sError = "貸出した資材数を超えて資材の返却はできません。"; 
+                        // 背景色変更
+                        CommonMotions.chgBackColor(r.Cells[(int)DispColumn.MaterialCount], bAns);
+                    }
+
+                    Regex regex = new Regex(@"^[0-9]+$");
+                    Match match = regex.Match(r.Cells[(int)DispColumn.MaterialCount].Value.ToString());
+                    if (!match.Success)
+                    {
+                        bAns = false;
+                        sError = "１以上の整数を入力してください。";
+                        CommonMotions.chgBackColor(r.Cells[(int)DispColumn.MaterialCount], bAns);
+                    }
+
+                    // コメント
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.CommentText].Value) != "")
+                    {
+                        // レングスチェック
+                        bAns = CommonMotions.chkStringLength(CommonMotions.cnvString(r.Cells[(int)DispColumn.CommentText].Value), 80);
+                        if (bAns == false)
+                        {
+                            sError = "入力エラーがあります、確認してください。";
+                            // 背景色変更
+                            CommonMotions.chgBackColor(r.Cells[(int)DispColumn.CommentText], bAns);
+                        }
+                    }
+                    bRet &= bAns;
+                }
+
+                if (!bRet)
+                {
+                    MessageBox.Show(sError, "データ確認"
+                                                , MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                }
+
+                return bRet;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+      }
+
+        /// <summary>
+        /// データ登録
+        /// </summary>
+        private void DataEntry()
+        {
+            IOMaterialInfo IoMi = new IOMaterialInfo();
+            IOConstructionMaterialInfo IoCmi = new IOConstructionMaterialInfo();
+            IOMaterialRecordInfo IoMri = new IOMaterialRecordInfo();
+
+            MaterialInfo MiWork;
+            ConstructionMaterialInfo CmiWork;
+            MaterialRecordInfo MriWork;
+
+            List<ConstructionMaterialInfo> CmiList;
+            List<MaterialRecordInfo> MriList;
+
+            try
+            {
+
+                IoMi.connect();
+                IoMi.beginTran();
+
+                IoCmi.connect();
+                IoCmi.beginTran();
+
+                IoMri.connect();
+                IoMri.beginTran();
+
+                foreach (DataGridViewRow r in dgvMaster.Rows)
+                {
+                    int intMaterialItemCode = CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialItemCode].Value);
+                    int intRentCount = CommonMotions.cnvInt(r.Cells[(int)DispColumn.RentCount].Value);
+                    int intRepayCount= CommonMotions.cnvInt(r.Cells[(int)DispColumn.RepayCount].Value);
+                    int intMaterialCount= CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialCount].Value);
+                    int intMaterialCountBefore = CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialCountBefore].Value);
+
+                    // 資材情報------------------------------------------------------------------------
+                    MiWork = new MaterialInfo();
+                    string strSQL = IoMi.CreatePrimarykeyString(intMaterialItemCode);
+                    List<MaterialInfo> MiList = new List<MaterialInfo>();
+                    if (!IoMi.SelectAction(strSQL, ref MiList, false))
+                    {
+                        MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+
+                    // 資材の返却完了判断
+                    int intDeleteMaterialCount = intRentCount - (intRepayCount + intMaterialCount);
+                    if (tglAllReturn.Checked && intDeleteMaterialCount != 0)
+                    {
+                        MiWork.MaterialCount = MiList[0].MaterialCount - intDeleteMaterialCount;
+                    }
+                    else
+                    {
+                        MiWork.MaterialCount = MiList[0].MaterialCount;
+                    }
+                    MiWork.RentCount = MiList[0].RentCount + (intMaterialCount - intMaterialCountBefore);
+
+                    // 更新ロック
+                    if (!IoMi.RowLockUpdate(intMaterialItemCode, false))
+                    {
+                        MessageBox.Show("他のユーザで編集中のため、処理できません。", "登録エラー"
+                        , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+
+                    // データ登録
+                    if (!IoMi.UpdateAction(strSQL, MiWork, false))
+                    {
+                        IoMi.rollback();
+                        MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+                    
+                    // 工事資材情報--------------------------------------------------------------------
+                    CmiWork = new ConstructionMaterialInfo();
+                    strSQL = IoCmi.CreatePrimarykeyString(ConstructionCode,intMaterialItemCode);
+                    CmiList = new List<ConstructionMaterialInfo>();
+                    if (!IoCmi.SelectAction(strSQL, ref CmiList, false))
+                    {
+                        IoMi.rollback();
+                        MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+
+                    CmiWork.RentCount = CmiList[0].RentCount;
+                    CmiWork.RepayCount = intRepayCount + intMaterialCount;
+                    if (tglAllReturn.Checked)
+                    {
+                        CmiWork.CompleteFlg = 1;
+                    }
+                    else
+                    {
+                        CmiWork.CompleteFlg = 0;
+                    }
+
+                    // ロック
+                    if (!IoCmi.RowLock(m_ConstructionCode, intMaterialItemCode, false))
+                    {
+                        IoMi.rollback();
+                        MessageBox.Show("他のユーザで編集中のため、処理できません。", "登録エラー"
+                        , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+
+                    // データ更新
+                    if (!IoCmi.UpdateAction(strSQL, CmiWork, false))
+                    {
+                        IoMi.rollback();
+                        IoCmi.rollback();
+                        MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+
+                    // 資材履歴情報------------------------------------------------------------------------
+                    MriWork = new MaterialRecordInfo();
+                    strSQL = IoMri.CreatePrimarykeyString(intMaterialItemCode,DateTime.Now.Date);
+                    strSQL += "and RecKind = 1";
+                    MriList = new List<MaterialRecordInfo>();
+                    if (!IoMri.SelectAction(strSQL, ref MriList, false))
+                    {
+                        IoMi.rollback();
+                        IoCmi.rollback();
+                        MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+
+                    MriWork.CommentText = CommonMotions.cnvString(r.Cells[(int)DispColumn.CommentText].Value);
+                    MriWork.ConstructionCode = m_ConstructionCode;
+                    MriWork.PersonCode = CommonMotions.LoginUserData.PersonCode;
+                    MriWork.RecKind = 1;
+                    MriWork.MaterialCount = intMaterialCount;
+
+                    if (MriList.Count == 0)     //  新規
+                    {
+                        strSQL = IoMri.CreatePrimarykeyString(intMaterialItemCode, DateTime.Now.Date);
+                        MriWork.MaterialItemCode = intMaterialItemCode;
+                        MriWork.ProcessDate = CommonMotions.cnvDate(lblRepaydate.Text);
+                        MriWork.SeqNo = IoMri.SelectMaxMaterialRecordKeyCount(strSQL, false) + 1;
+
+                        MriList.Clear();
+                        MriList.Add(MriWork);
+                        // データ登録
+                        if (!IoMri.InsertAction(MriList, false))
+                        {
+                            IoMi.rollback();
+                            IoCmi.rollback();
+                            IoMri.rollback();
+                            MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return;
+                        }
+
+                    }
+                    else　　　　　　//  更新
+                    {
+                        // ロック
+                        if (!IoMri.RowLock(intMaterialItemCode, MriList[0].ProcessDate, MriList[0].SeqNo, false))
+                        {
+                            IoMi.rollback();
+                            IoCmi.rollback();
+                            MessageBox.Show("他のユーザで編集中のため、処理できません。", "登録エラー"
+                            , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return;
+                        }
+
+                        // データ更新
+                        strSQL = IoMri.CreatePrimarykeyString(intMaterialItemCode, DateTime.Now.Date);
+                        strSQL += string.Format("and SeqNo = {0}", MriList[0].SeqNo);
+                        if (!IoMri.UpdateAction(strSQL, MriWork, false))
+                        {
+                            IoMi.rollback();
+                            IoCmi.rollback();
+                            IoMri.rollback();
+                            MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return;
+                        }
+
+                    }
+
+                }
+
+                IoMi.commit();
+                IoCmi.commit();
+                IoMri.commit();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                IoMi.close();
+                IoMi = null;
+
+                IoCmi.close();
+                IoCmi = null;
+
+                IoMri.close();
+                IoMri = null;
+            }
+        }
+
+        /// <summary>
+        /// 単位マスタ表示
+        /// </summary>
+        /// <returns></returns>
+        private bool DispGridData()
+        {
+            IOConstructionMaterialInfo IoCmi = new IOConstructionMaterialInfo();
+            ArrayList arData = new ArrayList();
+
+            try
+            {
+                // グリッドの行を0に戻す
+                dgvMaster.Rows.Clear();
+
+                // SQL作成
+                StringBuilder sql = new StringBuilder();
+                sql.AppendLine("select   Mkm.MaterialKindCode ");
+                sql.AppendLine("		,Mkm.MaterialKindName ");
+                sql.AppendLine("		,Mkm.DisplayOrder as KindDisp ");
+                sql.AppendLine("		,Mim.MaterialItemCode ");
+                sql.AppendLine("		,Mim.MaterialItemName ");
+                sql.AppendLine("        ,Mim.DisplayOrder as ItemDisp ");
+                sql.AppendLine("        ,Cmi.RENTCOUNT ");
+                sql.AppendLine("        ,Cmi.REPAYCOUNT - ifnull(Mri.MaterialCount,0) as REPAYCOUNT ");
+                sql.AppendLine("        ,ifnull(Mri.MaterialCount,0) as MaterialCount ");
+                sql.AppendLine("        ,ifnull(Mri.CommentText,'') as CommentText ");
+                sql.AppendLine("        ,Cmi.CompleteFlg ");
+                sql.AppendFormat("from ConstructionMaterialInfo as Cmi left join MaterialRecordInfo as Mri on Cmi.CONSTRUCTIONCODE = Mri.CONSTRUCTIONCODE and Cmi.MATERIALITEMCODE = Mri.MATERIALITEMCODE and Mri.RECKIND = 1 and ProcessDate = DATE_FORMAT('{0}','%Y/%m/%d') ", lblRepaydate.Text);
+                sql.AppendLine("									 left join (MaterialItemMaster as Mim left join MaterialKindMaster as Mkm on Mim.MaterialKindCode = Mkm.MaterialKindCode) on Cmi.MaterialItemCode = Mim.MaterialItemCode  ");
+                sql.AppendFormat("where Cmi.ConstructionCode = {0} ",ConstructionCode);
+                sql.AppendLine("order by Mkm.DisplayOrder ,Mim.DisplayOrder ");
+
+                // データ取得
+                if (!IoCmi.ExecuteReader(sql.ToString(), ref arData)) return false;
+
+                // データ表示
+                int icnt = 0;
+                bool CompleteFlg = true;
+                foreach (object[] work in arData)
+                {
+                    dgvMaster.Rows.Add();
+
+                    string chkString = CommonMotions.cnvString(work[(int)DataColumn.MaterialKindName]);
+
+                    if (!(icnt == 0
+                        || (icnt != 0 && (!chkString.Equals(dgvMaster.Rows[icnt - 1].Cells[(int)DispColumn.MaterialKindName].ToolTipText)))))
+                    {
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].Value = "";
+                    }
+                    else
+                    {
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].Value = CommonMotions.cnvString(work[(int)DataColumn.MaterialKindName]);
+                    }
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindCode].Value = CommonMotions.cnvInt(work[(int)DataColumn.MaterialKindCode]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].ToolTipText = CommonMotions.cnvString(work[(int)DataColumn.MaterialKindName]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindDisplayOrder].Value = CommonMotions.cnvInt(work[(int)DataColumn.KindDisp]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialItemCode].Value = CommonMotions.cnvInt(work[(int)DataColumn.MaterialItemCode]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialItemName].Value = CommonMotions.cnvString(work[(int)DataColumn.MaterialItemName]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialItemDisplayOrder].Value = CommonMotions.cnvInt(work[(int)DataColumn.ItemDisp]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.RentCount].Value = CommonMotions.cnvInt(work[(int)DataColumn.RENTCOUNT]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.RepayCount].Value = CommonMotions.cnvInt(work[(int)DataColumn.REPAYCOUNT]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialCount].Value = CommonMotions.cnvInt(work[(int)DataColumn.MaterialCount]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialCountBefore].Value = CommonMotions.cnvInt(work[(int)DataColumn.MaterialCount]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.CommentText].Value = CommonMotions.cnvString(work[(int)DataColumn.CommentText]);
+
+                    CompleteFlg = CommonMotions.cnvInt(work[(int)DataColumn.CompleteFlg]) == 1 ? false : true;
+                    icnt++;
+                }
+
+                // №再採番
+                LineReNumbering();
+
+                // 完了時画面操作不可
+                if (!CompleteFlg)
+                {
+                    tglAllReturn.Enabled = CompleteFlg;
+                    btnDataEntry.Enabled = CompleteFlg;
+                    dgvMaster.Enabled = CompleteFlg;
+                }
+
+                m_bChengeAns = false;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                IoCmi.close();
+                IoCmi = null;
+            }
+            return true;
+        }
+
+        /// <summary>
+        /// ボタンの表示・非表示制御
+        /// </summary>
+        private void ButtonVisble(Control Parent)
+        {
+            bool bAns = true;
+            if (m_DialogFlg){
+
+                bAns = false;
+            }
+            else
+            {
+                bAns = true;
+            }
+
+            foreach (Control ctrl in Parent.Controls)
+            {
+                if (ctrl.GetType().Equals(typeof(Button)))
+                {
+                    // 終了ボタン以外を制御する
+                    if (ctrl.Name.ToString() != btnEnd.Name.ToString()) ctrl.Visible = bAns;
+                }
+            }
+            // グリッドの読込のみ制御
+            dgvMaster.ReadOnly = m_DialogFlg;
+        }
+
+        /// <summary>
+        /// グリッド最終行での処理
+        /// </summary>
+        private void GridLastLine()
+        {
+            // 最終行判定
+            if (dgvMaster.CurrentCell.RowIndex == dgvMaster.Rows.Count - 1)
+            {
+                // 最終列判定
+                if (dgvMaster.CurrentCell.ColumnIndex == (int)DispColumn.CommentText)
+                {
+                    // 1行追加
+                    dgvMaster.Rows.Add();
+                    // クリアデータセット
+                    SetRowClearData(dgvMaster.Rows.Count - 1);
+                    // №再採番
+                    LineReNumbering();
+                }
+
+            }
+        }
+
+        /// <summary>
+        /// データ登録
+        /// </summary>
+        private bool DataEntryProcess()
+        {
+            try
+            {
+                //データチェック
+                if (!DispFeildCheck()) return false;
+
+                // 確認
+                if (tglAllReturn.Checked)
+                {
+                    if (MessageBox.Show("返却されていない資材は、資材から削除されます。完了してよろしいですか？", "登録確認"
+                            , MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return false;
+                }
+                else
+                {
+                    if (MessageBox.Show("表示中のデータを登録します。", "登録確認"
+                            , MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return false;
+                }
+
+                //// 表示行退避
+                //int iIndex = dgvMaster.FirstDisplayedScrollingRowIndex;
+
+                // データ登録
+                DataEntry();
+
+                // データ表示
+                if (!DispGridData()) return false;
+
+                //// 表示行復元
+                //dgvMaster.FirstDisplayedScrollingRowIndex = iIndex;
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+            return true;
+        }
+
+        #endregion
+
+
+
+
+    }
+}
\ No newline at end of file
